#include <stdlib.h>
#include <stdio.h>

#include "xmms/xmmsctrl.h"

#include "gg2_core.h"

#define USTAW_TLEN   1
#define USTAW_GG     2
#define USTAW_JABBER 3

#define TLEN_STATUS_AVAILABLE   2
#define TLEN_STATUS_EXT_AWAY    3
#define TLEN_STATUS_AWAY        4
#define TLEN_STATUS_DND         5
#define TLEN_STATUS_CHATTY      6
#define TLEN_STATUS_INVISIBLE   7
#define TLEN_STATUS_UNAVAILABLE 8

#define GG_STATUS_NOT_AVAIL 	  0x0001
#define GG_STATUS_NOT_AVAIL_DESCR 0x0015
#define GG_STATUS_AVAIL 	  0x0002
#define GG_STATUS_AVAIL_DESCR 	  0x0004
#define GG_STATUS_BUSY 		  0x0003
#define GG_STATUS_BUSY_DESCR 	  0x0005
#define GG_STATUS_INVISIBLE 	  0x0014
#define GG_STATUS_INVISIBLE_DESCR 0x0016

#define JABBER_STATUS_UNAVAILABLE 0
#define JABBER_STATUS_AVAILABLE   1
#define JABBER_STATUS_CHAT	  2
#define JABBER_STATUS_AWAY	  3
#define JABBER_STATUS_XA	  4
#define JABBER_STATUS_DND	  5

GGaduPlugin *handler;
GGaduStatusPrototype sp, *tlen_status, *gg_status, *jabber_status;
gpointer s;

GGaduMenu *menu;

gint timer = -1, gg_current_status, gg_last_status, tlen_current_status, tlen_last_status, jabber_current_status, jabber_last_status;
gint  xmms_pos;
guchar gg_i = 0;
gchar *desc, *last_desc = NULL;
gboolean tlen_set = FALSE, gg_set = FALSE, jabber_set = FALSE;

GGadu_PLUGIN_INIT("XMMS status", GGADU_PLUGIN_TYPE_MISC);

 
void GG_status_init() 
{
    gg_status = g_new0(GGaduStatusPrototype, 4);
    
    gg_status[gg_i].status = GG_STATUS_AVAIL_DESCR;
    gg_status[gg_i].description = g_strdup(_("Available with description"));
    gg_status[gg_i].image = g_strdup("gadu-gadu-online-descr.png");
    gg_status[gg_i].receive_only = FALSE;
    gg_i++;
    
    gg_status[gg_i].status = GG_STATUS_BUSY_DESCR;
    gg_status[gg_i].description = g_strdup(_("Busy with description"));
    gg_status[gg_i].image = g_strdup("gadu-gadu-away-descr.png");
    gg_status[gg_i].receive_only = FALSE;
    gg_i++;

    gg_status[gg_i].status = GG_STATUS_INVISIBLE_DESCR;
    gg_status[gg_i].description = g_strdup(_("Invisible with description"));
    gg_status[gg_i].image = g_strdup("gadu-gadu-invisible-descr.png");
    gg_status[gg_i].receive_only = FALSE;
    gg_i++;

    gg_status[gg_i].status = GG_STATUS_NOT_AVAIL_DESCR;
    gg_status[gg_i].description = g_strdup(_("Offline with description"));
    gg_status[gg_i].image = g_strdup("gadu-gadu-offline-descr.png");
    gg_status[gg_i].receive_only = FALSE;
    gg_i++;
}

void Tlen_status_init() 
{
    guchar tlen_i = 0;
    tlen_status = g_new0(GGaduStatusPrototype, 7);

    tlen_status[tlen_i].status = TLEN_STATUS_AVAILABLE;
    tlen_status[tlen_i].description = g_strdup(_("Available"));
    tlen_status[tlen_i].image = g_strdup("tlen-online.png");
    tlen_i++;

    tlen_status[tlen_i].status = TLEN_STATUS_EXT_AWAY;
    tlen_status[tlen_i].description = g_strdup(_("Very busy"));
    tlen_status[tlen_i].image = g_strdup("tlen-beback.png");
    tlen_i++;

    tlen_status[tlen_i].status = TLEN_STATUS_AWAY;
    tlen_status[tlen_i].description = g_strdup(_("Away"));
    tlen_status[tlen_i].image = g_strdup("tlen-away.png");
    tlen_i++;

    tlen_status[tlen_i].status = TLEN_STATUS_DND;
    tlen_status[tlen_i].description = g_strdup(_("DND"));
    tlen_status[tlen_i].image = g_strdup("tlen-occupied.png");
    tlen_i++;

    tlen_status[tlen_i].status = TLEN_STATUS_CHATTY;
    tlen_status[tlen_i].description = g_strdup(_("Chatty"));
    tlen_status[tlen_i].image = g_strdup("tlen-chat.png");
    tlen_i++;

    tlen_status[tlen_i].status = TLEN_STATUS_INVISIBLE;
    tlen_status[tlen_i].description = g_strdup(_("Invisible"));
    tlen_status[tlen_i].image = g_strdup("tlen-invisible.png");
    tlen_i++;

    tlen_status[tlen_i].status = TLEN_STATUS_UNAVAILABLE;
    tlen_status[tlen_i].description = g_strdup(_("Unavailable"));
    tlen_status[tlen_i].image = g_strdup("tlen-offline.png");
    tlen_i++;
}

void Jabber_status_init() 
{
    guchar jabber_i = 0;
    jabber_status = g_new0(GGaduStatusPrototype, 6);

    jabber_status[jabber_i].status = JABBER_STATUS_UNAVAILABLE;
    jabber_status[jabber_i].description = g_strdup(_("Unavailable"));
    jabber_status[jabber_i].image = g_strdup("jabber-offline.png");
    jabber_i++;
     
    jabber_status[jabber_i].status = JABBER_STATUS_AVAILABLE;
    jabber_status[jabber_i].description = g_strdup(_("Available"));
    jabber_status[jabber_i].image = g_strdup("jabber-online.png");
    jabber_i++;

    jabber_status[jabber_i].status = JABBER_STATUS_CHAT;
    jabber_status[jabber_i].description = g_strdup(_("Chat"));
    jabber_status[jabber_i].image = g_strdup("jabber-xa.png");
    jabber_i++;
    
    jabber_status[jabber_i].status = JABBER_STATUS_AWAY;
    jabber_status[jabber_i].description = g_strdup(_("Away"));
    jabber_status[jabber_i].image = g_strdup("jabber-away.png");
    jabber_i++;

    jabber_status[jabber_i].status = JABBER_STATUS_XA;
    jabber_status[jabber_i].description = g_strdup(_("XA"));
    jabber_status[jabber_i].image = g_strdup("jabber-xa.png");
    jabber_i++;

    jabber_status[jabber_i].status = JABBER_STATUS_DND;
    jabber_status[jabber_i].description = g_strdup(_("DND"));
    jabber_status[jabber_i].image = g_strdup("jabber-dnd.png");
    jabber_i++;
}

void set_GG(GGaduDialog *d) // ustawia status dla GG
{


	gg_last_status = gg_current_status;
	switch(gg_current_status)
	{
		case GG_STATUS_AVAIL:
			gg_i = 0;
			break;
		case GG_STATUS_BUSY:
			gg_i = 1;
			break;
		case GG_STATUS_INVISIBLE:
			gg_i = 2;
			break;
		case GG_STATUS_NOT_AVAIL:
			gg_i = 3;
			break;
	}
	d->user_data = &gg_status[gg_i];
	signal_emit(GGadu_PLUGIN_NAME, "change status descr",d, "gadu-gadu");
}

void set_Tlen(GGaduDialog *d) //ustawia status dla Tlen
{
	tlen_last_status = tlen_current_status;
	d->user_data = &tlen_status[tlen_current_status-2];
	signal_emit(GGadu_PLUGIN_NAME, "change status descr",d, "tlen");
}

void set_Jabber(GGaduDialog *d) //ustawia status dla Jabbera
{
	jabber_last_status = jabber_current_status;
	d->user_data = &jabber_status[jabber_current_status];
	signal_emit(GGadu_PLUGIN_NAME, "change status descr",d, "jabber");
}

gboolean check(gpointer data) //sprawdza czy utwor lub status sie zmienil
{
    GGaduDialog *d = ggadu_dialog_new(GGADU_DIALOG_GENERIC, NULL, NULL);
    GGaduKeyValue *kv = g_new0(GGaduKeyValue, 1);
    
    if(xmms_remote_is_playing(0))
    {
    	xmms_pos = xmms_remote_get_playlist_pos(0);
    	desc = xmms_remote_get_playlist_title(0,xmms_pos);
	
	if(gg_set == TRUE)
		gg_current_status = (gint)signal_emit(GGadu_PLUGIN_NAME, "get current status", NULL, "gadu-gadu");
	if(tlen_set == TRUE)
		tlen_current_status = (gint)signal_emit(GGadu_PLUGIN_NAME, "get current status", NULL, "tlen");
	if(jabber_set == TRUE)
		jabber_current_status = (gint)signal_emit(GGadu_PLUGIN_NAME, "get current status", NULL, "jabber");
	
    	if((g_strcasecmp(desc,last_desc)!= 0) || (tlen_last_status != tlen_current_status) || (gg_last_status != gg_current_status) || ((jabber_last_status != jabber_current_status) && (1 < jabber_current_status <= 5)))
    	{
	    	d->response = GGADU_OK;
	    	kv->value = (gpointer)desc;
		d->optlist = g_slist_append(d->optlist, kv);
		
		if(gg_set == TRUE) set_GG(d);
		if(tlen_set == TRUE) set_Tlen(d);
		if(jabber_set == TRUE) set_Jabber(d);
  	}
	g_free(last_desc);
  	last_desc = g_strdup(desc);
    }
    else if(last_desc != NULL) //czyszczenie po zakonczeniu XMMS
    {
	g_free(last_desc);
	last_desc = NULL;
	desc = '\0';

	d->response = GGADU_OK;
	kv->value = (gpointer)desc;
	d->optlist = g_slist_append(d->optlist, kv);

	if(gg_set == TRUE) set_GG(d);
	if(tlen_set == TRUE) set_Tlen(d);
	if(jabber_set == TRUE) set_Jabber(d);
    }

    if (!gg_set && !tlen_set && !jabber_set)
	GGaduDialog_free(d);

    return TRUE;
}

gpointer preferences(gpointer user_data)
{
    GGaduDialog *d;

    print_debug("%s : Preferences\n", GGadu_PLUGIN_NAME);

    d = ggadu_dialog_new(GGADU_DIALOG_CONFIG, _("Ustawienia XMMS status"), "config");
    ggadu_dialog_add_entry(d, USTAW_TLEN, _("Tlen"), VAR_BOOL, (gpointer) ggadu_config_var_get(handler, "tlen"), VAR_FLAG_NONE);
    ggadu_dialog_add_entry(d, USTAW_GG, _("GaduGadu"), VAR_BOOL, (gpointer) ggadu_config_var_get(handler, "gadugadu"), VAR_FLAG_NONE);
    ggadu_dialog_add_entry(d, USTAW_JABBER, _("Jabber"), VAR_BOOL, (gpointer) ggadu_config_var_get(handler, "jabber"), VAR_FLAG_NONE);
    
    signal_emit(GGadu_PLUGIN_NAME, "gui show dialog", d, "main-gui");

    return NULL;
} 

GGaduMenu *menuf()
{
    GGaduMenu *root = ggadu_menu_create();
    GGaduMenu *item = ggadu_menu_add_item(root, "XMMS status", NULL, NULL);

    ggadu_menu_add_submenu(item, ggadu_menu_new_item(_("Ustawienia"), preferences, NULL));
   
    return root;
}

void signal_receive(gpointer name, gpointer signal_ptr)
{
    GGaduSignal *signal = (GGaduSignal *) signal_ptr;

    print_debug("%s : received signal %d\n", GGadu_PLUGIN_NAME, signal->name);

    if (signal->name == g_quark_from_static_string("config"))
    {
	GGaduDialog *d = signal->data;
	GSList *tmplist = d->optlist;

	if (d->response == GGADU_OK)
	{
	    while (tmplist) 
	    {
		GGaduKeyValue *kv = (GGaduKeyValue *) tmplist->data;
		switch (kv->key)
		{
		case USTAW_TLEN:
		    print_debug("change var tlen to %d\n", kv->value);
		    ggadu_config_var_set(handler, "tlen", kv->value);
		    tlen_set = (gboolean)kv->value;
		    break;
		case USTAW_GG:
		    print_debug("change var gg to %d\n", kv->value);
		    ggadu_config_var_set(handler, "gadugadu", kv->value);
		    gg_set = (gboolean)kv->value;
		    break;
		    
		case USTAW_JABBER:
		    print_debug("change var jabber to %d\n", kv->value);
		    ggadu_config_var_set(handler, "jabber", kv->value);
		    jabber_set = (gboolean)kv->value;
		    break;
		
		}
		tmplist = tmplist->next;
	    }
	    ggadu_config_save(handler);
	}
	GGaduDialog_free(d);

	return;
    }
}

GGaduPlugin *initialize_plugin(gpointer conf_ptr)
{
    gchar *this_configdir = NULL;
    print_debug("%s : initialize\n", GGadu_PLUGIN_NAME);
    GGadu_PLUGIN_ACTIVATE(conf_ptr);
    handler = (GGaduPlugin *) register_plugin(GGadu_PLUGIN_NAME, _("XMMS status"));
    print_debug("%s : read configuration\n", GGadu_PLUGIN_NAME);
    if (g_getenv("CONFIG_DIR"))
	this_configdir = g_build_filename(g_get_home_dir(), g_getenv("CONFIG_DIR"), "gg2", NULL);
    else
	this_configdir = g_build_filename(g_get_home_dir(), ".gg2", NULL);
    ggadu_config_set_filename((GGaduPlugin *) handler, g_build_filename(this_configdir, "XMMS_status", NULL));

    g_free(this_configdir);

    ggadu_config_var_add(handler, "tlen", VAR_BOOL);
    ggadu_config_var_add(handler, "gadugadu", VAR_BOOL);
    ggadu_config_var_add(handler, "jabber", VAR_BOOL);
           
    if (!ggadu_config_read(handler))
	g_warning(_("Unable to read config file for plugin xmms_status"));

    register_signal_receiver((GGaduPlugin *) handler, (signal_func_ptr) signal_receive);

    return handler;
}

void start_plugin()
{
    print_debug("%s : start_plugin\n", GGadu_PLUGIN_NAME);
    register_signal(handler, "config");
    last_desc = g_strdup("");
    print_debug("%s : create menu\n", GGadu_PLUGIN_NAME);
    menu = menuf();
    signal_emit(GGadu_PLUGIN_NAME, "gui register menu", menu, "main-gui");
    
    tlen_set = (gboolean)ggadu_config_var_get(handler, "tlen");
    gg_set = (gboolean)ggadu_config_var_get(handler, "gadugadu");
    jabber_set = (gboolean)ggadu_config_var_get(handler, "jabber");
    
    GG_status_init();
    Tlen_status_init();
    Jabber_status_init();
    
    if (timer != -1)
	g_source_remove(timer);
	timer = g_timeout_add(10000, check, NULL);
	print_debug("%s : Timer ID set to %d\n", GGadu_PLUGIN_NAME, timer);
    
}

void destroy_plugin()
{
    print_debug("destroy_plugin %s\n", GGadu_PLUGIN_NAME);
    if (timer != -1)
	g_source_remove(timer);

    if (menu)
    {
	signal_emit(GGadu_PLUGIN_NAME, "gui unregister menu", menu, "main-gui");
	ggadu_menu_free(menu);
    }
}
